DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Attributes | List of all members
DcmQuantPixel Class Reference

objects of this class represent individual RGB pixels. More...

Inheritance diagram for DcmQuantPixel:

## Public Member Functions
| DcmQuantPixel ()
| default constructor, creates black pixel
| DcmQuantPixel (const DcmQuantPixel &arg)
| copy assignment constructor
virtual | ~DcmQuantPixel ()
| destructor
OFBool | operator== (const DcmQuantPixel &src) const
| comparison operator for equality
double | luminance () const
| this method computes the luminance of the current pixel according to the NTSC formula. More...
unsigned long | hash () const
| this method computes an unsigned long hash value for the current pixel. More...
DcmQuantComponent | getRed () const
| returns the red component More...
DcmQuantComponent | getGreen () const
| returns the green component More...
DcmQuantComponent | getBlue () const
| returns the blue component More...
void | assign (DcmQuantComponent r, DcmQuantComponent g, DcmQuantComponent b)
| assigns new R, G and B values to this pixel More...
void | scale (DcmQuantComponent r, DcmQuantComponent g, DcmQuantComponent b, const DcmQuantScaleTable &table)
| assigns new R, G and B values to this pixel using the given scale table in which all three values are looked up. More...

## Private Attributes
DcmQuantComponent | red
| red color component of this pixel
DcmQuantComponent | green
| green color component of this pixel
DcmQuantComponent | blue
| blue color component of this pixel

## Detailed Description

objects of this class represent individual RGB pixels.

This class is used by the color quantization classes. For efficiency considerations, all methods are declared inline.

## Member Function Documentation

## ◆ assign()

void DcmQuantPixel::assign | ( | DcmQuantComponent | r,
|  | DcmQuantComponent | g,
|  | DcmQuantComponent | b
| ) |  |
| inline

assigns new R, G and B values to this pixel

Parameters

  r | new R
  g | new G
  b | new B

## ◆ getBlue()

DcmQuantComponent DcmQuantPixel::getBlue | ( |  | ) | const
| inline

returns the blue component

Returns
  blue component of this pixel

Referenced by DcmQuantFloydSteinberg::adjust().

## ◆ getGreen()

DcmQuantComponent DcmQuantPixel::getGreen | ( |  | ) | const
| inline

returns the green component

Returns
  green component of this pixel

Referenced by DcmQuantFloydSteinberg::adjust().

## ◆ getRed()

DcmQuantComponent DcmQuantPixel::getRed | ( |  | ) | const
| inline

returns the red component

Returns
  red component of this pixel

Referenced by DcmQuantFloydSteinberg::adjust().

## ◆ hash()

unsigned long DcmQuantPixel::hash | ( |  | ) | const
| inline

this method computes an unsigned long hash value for the current pixel.

The hash algorithm is taken from Jef Poskanzer's ppm utility library. The return value is guaranteed to be < DcmQuantHashSize.

Returns
  hash value for current pixel

Referenced by DcmQuantColorHashTable::item(), and DcmQuantColorHashTable::lookup().

## ◆ luminance()

double DcmQuantPixel::luminance | ( |  | ) | const
| inline

this method computes the luminance of the current pixel according to the NTSC formula.

The range of the luminance equals the range of the underlying DcmQuantComponent type. However, the luminance is returned as a double.

Returns
  luminance of this pixel

## ◆ scale()

void DcmQuantPixel::scale | ( | DcmQuantComponent | r,
|  | DcmQuantComponent | g,
|  | DcmQuantComponent | b,
|  | const DcmQuantScaleTable & | table
| ) |  |
| inline

assigns new R, G and B values to this pixel using the given scale table in which all three values are looked up.

Parameters

  r | new R
  g | new G
  b | new B
  table | scale table (LUT) in which R, G and B are looked up.

The documentation for this class was generated from the following file:

- dcmimage/include/dcmtk/dcmimage/diqtpix.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1